
// Eurobot13 EmergencyStop.h

#include "mbed.h"
#include "Actuators/Actuator.h" 

class EmergencyStop : public InterruptIn{
    private:
    public:
    EmergencyStop   ( PinName pin
                    , void (*risefunction)(void) = Actuator::haltandCatchFire
                    , void (*fallfunction)(void) = Actuator::haltandCatchFire
                    ) 
                    : InterruptIn(pin)
                    {
    if (risefunction != NULL){
        rise(risefunction);
        }
        
    if (fallfunction != NULL){
        fall(fallfunction); 
        }
    }
};